<template>
  <div class="infrastructure-page">
    <q-page padding>
      <!-- <h6>Infrastructure</h6>
      <p>How to communicate with Karmada:</p>
      <p>Details on how to establish and manage communication with Karmada.</p> -->

      <!-- Cluster Table -->
      <div class="section">
        <h6>Nephele Cluster Information</h6>
        <div v-if="isLoadingClusters">Loading clusters...</div>
        <div v-else-if="errorClusters">{{ errorClusters }}</div>
        <div v-else>
          <q-table :rows="clusters" :columns="clusterColumns" row-key="id">
            <template v-slot:body-cell-grafana="props">
              <q-td :props="props">
                <!-- Use QBtn if the URL is available, otherwise display 'N/A' -->
                <q-btn
                  v-if="props.row.grafana"
                  flat
                  color="primary"
                  @click="gotoGrafanaLink(props.row.grafana)"
                  label="Grafana"
                ></q-btn>
                <span v-else>N/A</span>
              </q-td>
            </template></q-table
          >
        </div>
      </div>

      <!-- IoT Devices Table -->
      <div class="section">
        <h6>Nephele Registered IoT Devices</h6>
        <div v-if="isLoadingDevices">Loading devices...</div>
        <div v-else-if="errorDevices">{{ errorDevices }}</div>
        <div v-else>
          <q-table :rows="devices" :columns="iotColumns" row-key="id">
            <template v-slot:body-cell-thing_descriptor="props">
              <q-td :props="props">
                <q-btn
                  flat
                  label="View Descriptor"
                  @click="openDescriptorPopup(props.row.thing_descriptor)"
                ></q-btn>
              </q-td> </template
          ></q-table>
        </div>
      </div>

      <q-dialog v-model="isDescriptorPopupOpen">
        <q-card>
          <q-card-section>
            <div class="text-h6">Descriptor Details</div>
          </q-card-section>
          <q-card-section>
            <div v-if="currentDescriptor">
              <div v-for="(value, key) in currentDescriptor" :key="key">
                <strong>{{ key }}:</strong> {{ value }}
              </div>
            </div>
          </q-card-section>
          <q-card-actions align="right">
            <q-btn
              flat
              label="Close"
              @click="isDescriptorPopupOpen = false"
            ></q-btn>
          </q-card-actions>
        </q-card>
      </q-dialog>
    </q-page>
  </div>
</template>

<script setup lang="ts">
import { QPage, QTable } from 'quasar';
import { ref, onMounted } from 'vue';
import { useFetchClusters } from '../hooks/clusters';
import { useFetchDevices } from '../hooks/devices';

const {
  clusters: clustersRef,
  fetchClusters,
  isLoading: isLoadingClusters,
  error: errorClusters,
} = useFetchClusters();
const {
  devices: devicesRef,
  fetchDevices,
  isLoading: isLoadingDevices,
  error: errorDevices,
} = useFetchDevices();

const clusters = ref([]);
const devices = ref([]);
const isDescriptorPopupOpen = ref(false);
const currentDescriptor = ref(null);

function openDescriptorPopup(descriptor) {
  currentDescriptor.value = descriptor;
  isDescriptorPopupOpen.value = true;
}

onMounted(async () => {
  await fetchClusters();
  clusters.value = clustersRef.value.flat();

  await fetchDevices();
  devices.value = devicesRef.value.flat();
});

// Clusters Table Columns
const clusterColumns = ref([
  {
    name: 'cluster_name',
    align: 'left',
    label: 'Cluster Name',
    field: 'name',
    sortable: true,
  },
  {
    name: 'availability',
    align: 'left',
    label: 'Availability',
    field: (row) => (row.availability ? 'Yes' : 'No'),
    sortable: true,
  },
  {
    name: 'location',
    align: 'left',
    label: 'Location',
    field: 'location',
    sortable: true,
  },
  {
    name: 'available_cpu',
    align: 'left',
    label: 'Available CPU',
    field: 'available_cpu',
    sortable: true,
  },
  {
    name: 'available_ram',
    align: 'left',
    label: 'Available RAM',
    field: 'available_ram',
    sortable: true,
  },
  {
    name: 'pod_cidr',
    align: 'left',
    label: 'Pod CIDR Network',
    field: 'pod_cidr',
    sortable: true,
  },
  {
    name: 'service_cidr',
    align: 'left',
    label: 'Service CIDR Network',
    field: 'service_cidr',
    sortable: true,
  },
  {
    name: 'grafana',
    align: 'left',
    label: 'Grafana Link',
    field: 'grafana',
    format: (val) =>
      val ? `<a href="${val}" target="_blank">Link</a>` : 'N/A',
    sortable: true,
    html: true,
  },
]);

// IoT Devices Table Columns
const iotColumns = ref([
  {
    name: 'title',
    align: 'left',
    label: 'Title',
    field: (row) => row.thing_descriptor.title,
    sortable: true,
  },
  {
    name: 'device_type',
    align: 'left',
    label: 'Device Type',
    field: 'device_type',
    sortable: true,
  },
  { name: 'ip', align: 'left', label: 'IP', field: 'ip', sortable: true },
  {
    name: 'location',
    align: 'left',
    label: 'Location',
    field: 'location',
    sortable: true,
  },
  {
    name: 'thing_descriptor',
    align: 'left',
    label: 'Descriptor',
    field: 'thing_descriptor',
    sortable: false,
  },
]);
function gotoGrafanaLink(url: string) {
  window.open(url, '_blank');
}
</script>

<style scoped>
.infrastructure-page .section {
  margin-bottom: 20px;
}

.map-image {
  width: 100%;
  max-width: 600px;
  /* Adjust based on your needs */
  margin-top: 20px;
}
</style>
